# WordPress for Android Docs

## Development Practices

- [Coding Style](coding-style.md) - guidelines and validation and auto-formatting tools
- [Using Android Resources](using-android-resources.md) - describes how to add or use Android resources like strings and drawables
- [Localization](localization.md)
- [Pull Request Guidelines](pull-request-guidelines.md) - branch naming and how to write good pull requests
- [UI Tests](../WordPress/src/androidTest/java/org/wordpress/android/e2e/)

## Accessibility

- [Accessibility Guidelines](accessibility-guidelines.md)
- [TalkBack Guidelines](talkback-guidelines.md)
- [Right to Left Layout Guidelines](right-to-left-layout-guidelines.md)

## Others

- [Frequently Asked Questions](faq.md)
- [Issue Triage](issue-triage.md)

## Further Reading

- [Handbook: Git Branching Guidelines](https://make.wordpress.org/mobile/handbook/general-guides/git-branching/)

## External Resources 

- [WordPress Mobile Blog](http://make.wordpress.org/mobile)
- [WordPress Mobile Handbook](http://make.wordpress.org/mobile/handbook/)
