# Pull Request Guidelines

## Branch Naming

Please read [Feature Branches](https://make.wordpress.org/mobile/handbook/general-guides/git-branching/#feature-branches) in the Handbook to learn how to name your Git branches.

## Commits

As you commit code to these branches, don’t tag the issue number in the individual commit messages as it pollutes the pull request and makes it messier, just attach the issue number to the final pull request. Before you submit your final pull request, make sure all your branches are up to date with `trunk`.

## Anatomy of a Good Pull Request

When you are ready, please, spend time crafting a good Pull Request, since it will have a huge impact on the work of reviewers, release managers and testers.

**Title**: A good descriptive title.

**Issue**: Link to the GitHub issue this PR addresses.

**Description**: Take the time to write a good summary. Why is it needed? What does it do? When fixing bugs try to avoid just writing “See original issue” – clarify what the problem was and how you’ve fixed it.

**Testing instructions**: Step by step testing instructions. When necessary break out individual scenarios that need testing, consider including a checklist for the reviewer to go through.

**Images and Gif**: Include before and after images or gifs when appropriate.

**Labels**: We have labels for different types of PRs as well as different application areas, use them accordingly.



_Thank you very much for contributing to WordPress for Android!_
